## ros-kinetic-jsk-topic-tools 2.2.11

=== CMakeLists.txt ===
# http://ros.org/doc/groovy/api/catkin/html/user_guide/supposed.html
cmake_minimum_required(VERSION 2.8.3)
project(jsk_topic_tools)

# Use ccache if installed to make it fast to generate object files
find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(CCACHE_FOUND)

find_package(catkin REQUIRED COMPONENTS
  dynamic_reconfigure
  eigen_conversions
  geometry_msgs
  image_transport
  message_generation
  nodelet
  roscpp
  rostime
  std_msgs
  std_srvs
  tf
  topic_tools
)
catkin_python_setup()
add_message_files(
  FILES TopicInfo.msg
)
add_service_files(
  FILES List.srv Update.srv ChangeTopic.srv PassthroughDuration.srv
)
generate_dynamic_reconfigure_options(
  cfg/LightweightThrottle.cfg
  cfg/StealthRelay.cfg
  cfg/SynchronizedThrottle.cfg
)
generate_messages()
catkin_package(
    DEPENDS
    CATKIN_DEPENDS topic_tools message_runtime nodelet std_msgs std_srvs roscpp rostime
    INCLUDE_DIRS include
    LIBRARIES jsk_topic_tools
    CFG_EXTRAS nodelet.cmake
)

if(topic_tools_VERSION VERSION_GREATER "1.13.2")
  add_definitions("-Dtopic_tools_relay_stealth_EXISTS")
endif()

include_directories(include ${catkin_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})
if(NOT APPLE)
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -z defs")
endif(NOT APPLE)
#include_directories(${Boost_INCLUDE_DIRS})
add_executable(standalone_complexed_nodelet src/standalone_complexed_nodelet.cpp src/log_utils.cpp)
add_executable(topic_buffer_server src/topic_buffer_server.cpp)
add_executable(topic_buffer_client src/topic_buffer_client.cpp)
add_executable(transform_merger src/transform_merger.cpp)
add_executable(static_transform_pose_stamped
  src/static_transform_pose_stamped.cpp)
target_link_libraries(transform_merger ${catkin_LIBRARIES})
target_link_libraries(static_transform_pose_stamped ${catkin_LIBRARIES})
add_dependencies(static_transform_pose_stamped ${PROJECT_NAME}_gencpp)
add_dependencies(topic_buffer_server ${PROJECT_NAME}_gencpp)
add_dependencies(topic_buffer_client ${PROJECT_NAME}_gencpp)
target_link_libraries(topic_buffer_server ${catkin_LIBRARIES})
target_link_libraries(topic_buffer_client ${catkin_LIBRARIES})
target_link_libraries(standalone_complexed_nodelet ${catkin_LIBRARIES})

include(${PROJECT_SOURCE_DIR}/cmake/nodelet.cmake)

macro(jsk_topic_tools_nodelet _nodelet_cpp _nodelet_class _single_nodelet_exec_name)
  jsk_nodelet(${_nodelet_cpp} ${_nodelet_class} ${_single_nodelet_exec_name}
    jsk_topic_tools_nodelet_sources jsk_topic_tools_nodelet_executable_names)
endmacro(jsk_topic_tools_nodelet _nodelet_cpp _nodelet_class _single_nodelet_exec_name)

# nodelet shared object
jsk_topic_tools_nodelet(src/lightweight_throttle_nodelet.cpp
  "jsk_topic_tools/LightweightThrottle" "lightweight_throttle")
jsk_topic_tools_nodelet(src/mux_nodelet.cpp
  "jsk_topic_tools/MUX" "mux")
jsk_topic_tools_nodelet(src/relay_nodelet.cpp
  "jsk_topic_tools/Relay" "relay")
jsk_topic_tools_nodelet(src/deprecated_relay_nodelet.cpp
  "jsk_topic_tools/DeprecatedRelay" "deprecated_relay")
jsk_topic_tools_nodelet(src/stealth_relay_nodelet.cpp
  "jsk_topic_tools/StealthRelay" "stealth_relay")
jsk_topic_tools_nodelet(src/passthrough_nodelet.cpp
  "jsk_topic_tools/Passthrough" "passthrough")
jsk_topic_tools_nodelet(src/block_nodelet.cpp
  "jsk_topic_tools/Block" "block")
jsk_topic_tools_nodelet(src/snapshot_nodelet.cpp
  "jsk_topic_tools/Snapshot" "snapshot")
jsk_topic_tools_nodelet(src/hz_measure_nodelet.cpp
  "jsk_topic_tools/HzMeasure" "hz_measure")
jsk_topic_tools_nodelet(src/vital_checker_nodelet.cpp
  "jsk_topic_tools/VitalCheckerNodelet" "vital_checker")
jsk_topic_tools_nodelet(src/string_relay_nodelet.cpp
  "jsk_topic_tools/StringRelay" "string_relay")
jsk_topic_tools_nodelet(src/synchronized_throttle_nodelet.cpp
  "jsk_topic_tools/SynchronizedThrottle" "synchronized_throttle")

add_library(jsk_topic_tools SHARED
  ${jsk_topic_tools_nodelet_sources}
  src/timered_diagnostic_updater.cpp
  src/diagnostic_utils.cpp
  src/rosparam_utils.cpp
  src/time_accumulator.cpp
  src/vital_checker.cpp
  src/color_utils.cpp
  src/log_utils.cpp
  src/connection_based_nodelet.cpp
  src/diagnostic_nodelet.cpp
  src/series_boolean.cpp
  src/counter.cpp)
add_dependencies(jsk_topic_tools ${PROJECT_NAME}_gencpp ${PROJECT_NAME}_gencfg)
target_link_libraries(jsk_topic_tools ${catkin_LIBRARIES})

if (CATKIN_ENABLE_TESTING)
  find_package(roslint REQUIRED)
  set(ROSLINT_CPP_OPTS "--filter=-whitespace/parens,-whitespace/braces")
  roslint_cpp()
  roslint_python()
  macro(jsk_topic_tools_add_rostest file)
    list(APPEND jsk_topic_tools_test_files ${file})
    add_rostest(${file})
  endmacro()
  find_package(rostest REQUIRED)
  jsk_topic_tools_add_rostest(test/test_topic_buffer.test)
  jsk_topic_tools_add_rostest(test/test_topic_buffer_close_wait.test)
  jsk_topic_tools_add_rostest(test/test_topic_buffer_fixed_rate.test)
  jsk_topic_tools_add_rostest(test/test_topic_buffer_fixed_rate_and_update_rate.test)
  jsk_topic_tools_add_rostest(test/test_topic_buffer_update_rate.test)
  jsk_topic_tools_add_rostest(test/test_lightweight_throttle.test)
  jsk_topic_tools_add_rostest(test/test_topic_compare.test)
  jsk_topic_tools_add_rostest(test/test_hz_measure.test)
  jsk_topic_tools_add_rostest(test/test_block.test)
  jsk_topic_tools_add_rostest(test/test_connection_based_nodelet.test)
  jsk_topic_tools_add_rostest(test/test_connection_based_transport.test)
  jsk_topic_tools_add_rostest(test/test_stealth_relay.test)
  jsk_topic_tools_add_rostest(test/test_synchronized_throttle.test)
  jsk_topic_tools_add_rostest(test/test_pose_stamped_publisher.test)
  catkin_add_nosetests(src/jsk_topic_tools/tests)
  catkin_add_gtest(test_rosparam_utils src/tests/test_rosparam_utils.cpp)
  target_link_libraries(test_rosparam_utils ${PROJECT_NAME})
  add_rostest_gtest(test_log_utils test/test_log_utils.launch src/tests/test_log_utils.cpp)
  target_link_libraries(test_log_utils ${PROJECT_NAME})

  # nodelets for testing
  add_library(jsk_topic_tools_test src/tests/test_log_utils_nodelet.cpp)
  target_link_libraries(jsk_topic_tools_test ${PROJECT_NAME})
  # testing with loading nodelet
  add_rostest_gtest(test_nodelet_log_utils test/test_nodelet_log_utils.test test/test_nodelet_log_utils.cpp)
  target_link_libraries(test_nodelet_log_utils ${PROJECT_NAME})
  add_dependencies(test_nodelet_log_utils jsk_topic_tools_test)
  if("$ENV{ROS_DISTRO}" STRGREATER "indigo")
    # rostest/publishtest is available on kinetic and later
    jsk_topic_tools_add_rostest(test/test_standalone_complexed_nodelet.test)
  elseif("$ENV{ROS_DISTRO}" STRGREATER "hydro")
    # FIXME: jsk_tools/test_topic_published.py does not work on hydro travis/jenkins
    # https://github.com/jsk-ros-pkg/jsk_common/pull/1293#issuecomment-164158260
    jsk_topic_tools_add_rostest(test/test_tf_to_pose.test)
  endif()
endif()

# From https://github.com/jsk-ros-pkg/jsk_recognition/pull/2345
# Install header files directly into ${CATKIN_PACKAGE_INCLUDE_DESTINATION}.
# If the package has setup.py and modules under src/${PROJECT_NAME}/,
# install python executables directly into ${CATKIN_PACKAGE_BIN_DESTINATION}.
# However, if it doesn't have setup.py, directories including python executables
# should be installed recursively into ${CATKIN_PACKAGE_SHARE_DESTINATION}.
# Also, other directories like 'launch' or 'sample' must be installed
# recursively into ${CATKIN_PACKAGE_SHARE_DESTINATION}.
# Be careful that 'launch' and 'launch/' are different: the former is directory
# and the latter is each content.
install(TARGETS topic_buffer_server topic_buffer_client jsk_topic_tools
  ${jsk_topic_tools_nodelet_executable_names}
  standalone_complexed_nodelet
  static_transform_pose_stamped
  transform_merger
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(FILES
  jsk_topic_tools_nodelet.xml
  jsk_topic_tools_test_nodelet.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(DIRECTORY scripts/
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  USE_SOURCE_PERMISSIONS
)

install(FILES ${jsk_topic_tools_test_files}
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/test
)
install(DIRECTORY test
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
  USE_SOURCE_PERMISSIONS
  PATTERN "*.test" EXCLUDE
)
install(DIRECTORY cmake config launch sample
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
  USE_SOURCE_PERMISSIONS
)

=== debian/changelog ===
ros-kinetic-jsk-topic-tools (2.2.11-1xenial) xenial; urgency=high

  * [jsk_topic_tools] check nodelet version>=1.9.10 (#1647 <https://github.com/jsk-ros-pkg/jsk_common/issues/1647>)
  * [jsk_topic_tools/scripts/pose_stamped_publisher.py] fix orientation bug (#1649 <https://github.com/jsk-ros-pkg/jsk_common/issues/1649>)
  * Fix for noetic build (#1648 <https://github.com/jsk-ros-pkg/jsk_common/issues/1648>)
    
      * fix for python3, except, print ....
      * fix print(), Exception as e for python3
      * fox for boost 1.67 (20.04)
      * migrate to noetic with ROS_PYTHON_VERSION=2/3, use multiple ROS distro strategy http://wiki.ros.org/noetic/Migration
      * upgrade package.xml to format=3
    
  * call ros::param::get before set not to overwrite (#1643 <https://github.com/jsk-ros-pkg/jsk_common/issues/1643>)
    
      * run test_standalone_complexed_nodelet.test
      * add test code for standalone_complexed_nodelet
      * call ros::param::get before set not to overwrite
    
  * [jsk_topic_tools/SynchronizedThrottle] Reset sync policy in destructor (#1640 <https://github.com/jsk-ros-pkg/jsk_common/issues/1640>)
  * [jsk_topic_tools] import _pickle as pickle for python3 (#1636 <https://github.com/jsk-ros-pkg/jsk_common/issues/1636>)
    
      * add comment in log_utils
      * import _pickle as pickle for python3, cpickle is no more used in python3
    
  * add SoundRequest.volume for kinetic (#1635 <https://github.com/jsk-ros-pkg/jsk_common/issues/1635>)
  * Create tf.TransformListener before run timerf( #1634 <https://github.com/jsk-ros-pkg/jsk_common/issues/1634>)
    
      * Assign listener varaible before run timer and the callback in order, not to lookup listener variable before it is assigned.
    
  * [jsk_tools] Add --ping-trials option to roscore_regardless.pyf( #1632 <https://github.com/jsk-ros-pkg/jsk_common/issues/1632>)
    
      * Sometimes ping is not stable. --ping-trials option enables roscore_regardless.py to verify host computer of rosmaster is alive by multi-times ping commands.
    
  * [deprecated_relay] print warning message only when relayed topic is subscribed (#1624 <https://github.com/jsk-ros-pkg/jsk_common/issues/1624>)
    
      * print warn only when the msg is subscribed
      * print warn only once in starting
    
  * [jsk_tools] Add --timeout option to roscore_regardless.py (#1622 <https://github.com/jsk-ros-pkg/jsk_common/issues/1622>)
  * standalone_complexed_nodelet: add params key for each nodelet (#1614 <https://github.com/jsk-ros-pkg/jsk_common/issues/1614>)
    
      * Add --timeout option to change timeout duration of ping command towards rosmaster computer.
      * --timeout option defaults to 10 seconds.
    
  * jsk_nodelet: fix overwritting find_package(boost) (#1618 <https://github.com/jsk-ros-pkg/jsk_common/issues/1618>)
  * synchronized_throttle: add some more infos (#1615 <https://github.com/jsk-ros-pkg/jsk_common/issues/1615>)
  * stealth_relay_nodelet: fix error double free or corruption (fasttop) (#1613 <https://github.com/jsk-ros-pkg/jsk_common/issues/1613>)
    
      * update standalone_complexed_nodelet sample launch
      * standalone_complexed_ndoelet: support params tag
    
  * Contributors: Furushchev, Kei Okada, Ryo Koyama, Ryohei Ueda, Shingo Kitagawa, Yuki Furuta, Iory Yanokura

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Fri, 10 Jul 2020 00:00:00 -0000

ros-kinetic-jsk-topic-tools (2.2.10-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sat, 03 Nov 2018 00:00:00 -0000

ros-kinetic-jsk-topic-tools (2.2.9-1xenial) xenial; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Fri, 02 Nov 2018 00:00:00 -0000

ros-kinetic-jsk-topic-tools (2.2.8-1xenial) xenial; urgency=high

  * Fix to install 'scripts' directory (#1604 <https://github.com/jsk-ros-pkg/jsk_common/issues/1604>)
  * Add reset to Timer in ConnectionBasedTransport (#1597 <https://github.com/jsk-ros-pkg/jsk_common/issues/1597>)
    * Check if >=kinetic to pass reset arg to Timer
  * Add test for data_collection_server (#1599 <https://github.com/jsk-ros-pkg/jsk_common/issues/1599>)
    * Stop using cv2 in static_image_publisher.pyTo fix
    https://github.com/jsk-ros-pkg/jsk_common/pull/1599#issuecomment-417908500
    
      * Add reset to Timer in ConnectionBasedTransport
        To fix below:
        ```
    [ERROR] [1535796247.786932, 1535792085.063646]: [/get_heightmap] [sleep] ROS time moved backwards: 1.407559397s
    Exception in thread Thread-4:
    Traceback (most recent call last):
    File "/usr/lib/python2.7/threading.py", line 801, in __bootstrap_inner
    self.run()
    File "/opt/ros/kinetic/lib/python2.7/dist-packages/rospy/timer.py", line 226, in run
    r.sleep()
    File "/opt/ros/kinetic/lib/python2.7/dist-packages/rospy/timer.py", line 103, in sleep
    sleep(self._remaining(curr_time))
    File "/opt/ros/kinetic/lib/python2.7/dist-packages/rospy/timer.py", line 164, in sleep
    raise rospy.exceptions.ROSTimeMovedBackwardsException(time_jump)
    ROSTimeMovedBackwardsException: ROS time moved backwards
    Exception in thread Thread-4:
    Traceback (most recent call last):
    File "/usr/lib/python2.7/threading.py", line 801, in __bootstrap_inner
    self.run()
    File "/opt/ros/kinetic/lib/python2.7/dist-packages/rospy/timer.py", line 226, in run
    r.sleep()
    File "/opt/ros/kinetic/lib/python2.7/dist-packages/rospy/timer.py", line 103, in sleep
    sleep(self._remaining(curr_time))
    File "/opt/ros/kinetic/lib/python2.7/dist-packages/rospy/timer.py", line 164, in sleep
    raise rospy.exceptions.ROSTimeMovedBackwardsException(time_jump)
    ROSTimeMovedBackwardsException: ROS time moved backwards
    ^C[image_view-9] killing on exit
    [tile_image-8] killing on exit
    [get_heightmap/output/depth_view-7] killing on exit
    [get_heightmap-6] killing on exit
    [heightmap_frame_publisher-5] killing on exit
    [bbox_to_tf-4] killing on exit


=== debian/control ===
Source: ros-kinetic-jsk-topic-tools
Section: misc
Priority: optional
Maintainer: Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>
Build-Depends: debhelper (>= 9.0.0), ros-kinetic-catkin, ros-kinetic-diagnostic-msgs, ros-kinetic-diagnostic-updater, ros-kinetic-dynamic-reconfigure, ros-kinetic-dynamic-tf-publisher, ros-kinetic-eigen-conversions, ros-kinetic-geometry-msgs, ros-kinetic-image-transport, ros-kinetic-message-generation, ros-kinetic-nodelet (>= 1.9.11), ros-kinetic-roscpp, ros-kinetic-roscpp-tutorials, ros-kinetic-roslaunch, ros-kinetic-roslint, ros-kinetic-rosnode, ros-kinetic-rostest, ros-kinetic-rostime, ros-kinetic-rostopic, ros-kinetic-std-msgs, ros-kinetic-std-srvs, ros-kinetic-tf, ros-kinetic-topic-tools
Homepage: http://ros.org/wiki/jsk_topic_tools
Standards-Version: 3.9.2

Package: ros-kinetic-jsk-topic-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python-numpy, python-opencv, python-scipy, ros-kinetic-diagnostic-msgs, ros-kinetic-diagnostic-updater, ros-kinetic-dynamic-reconfigure, ros-kinetic-dynamic-tf-publisher, ros-kinetic-eigen-conversions, ros-kinetic-geometry-msgs, ros-kinetic-image-transport, ros-kinetic-message-runtime, ros-kinetic-nodelet (>= 1.9.11), ros-kinetic-roscpp, ros-kinetic-roslaunch, ros-kinetic-rosnode, ros-kinetic-rostime, ros-kinetic-rostopic, ros-kinetic-sensor-msgs, ros-kinetic-sound-play, ros-kinetic-std-msgs, ros-kinetic-std-srvs, ros-kinetic-tf, ros-kinetic-topic-tools
Description: jsk_topic_tools

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-jsk-topic-tools//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
